package body BoundedBuffers is

   protected body BBuffer is

      entry Get(Item: out Message)
        when Total_In_Buffer /= 0
      is
      begin
         Item:= Store(First_Out);
         First_Out:= First_Out+1;
         Total_In_Buffer:= Total_In_Buffer-1;
      end Get;

      entry Put(Item: Message)
        when Total_In_Buffer /= Count'Last
      is
      begin
         Store(First_In):= Item;
         First_In:= First_In+1;
         Total_In_Buffer:= Total_In_Buffer+1;
      end Put;

      function Buffer_Avail return Count
      is
      begin
         return Count'Last-Total_In_Buffer;
      end Buffer_Avail;
   end BBuffer;
end BoundedBuffers;
