generic
   type Message is private;
   type BB_Range is mod <>;
package BoundedBuffers is
   subtype Count is Natural range 0..BB_Range'Modulus;
   type Buffer_Array is array(BB_Range) of Message;
   protected type BBuffer is
      entry Get(Item: out Message);
      entry Put(Item: Message);
      function Buffer_Avail return Count;
   private
      First_In: BB_Range:= BB_Range'First;
      First_Out: BB_Range:= BB_Range'First;
      Total_In_Buffer: Count:=0;
      Store: Buffer_Array;
   end BBuffer;
end BoundedBuffers;
